Introduction

What is rulesPlayer?

rulesPlayer is a clean and easy-to-use GUI for MPlayer under Windows, written in D and DWT. rulesPlayer supports most popular media files (AVI, 3gp, ASF, FLV, Matroska, MOV QuickTime, MP4, NUT, Ogg, OGM, RealMedia, DivX plus many more) supported by many native, XAnim, and Win32 DLL codecs. You can watch VideoCD, SVCD, DVD, 3ivx, DivX 3/4/5 and even can watch video files while you are downloading them! rulesPlayer also has an onscreen display (OSD) for status information, nice big antialiased shaded subtitles and visual feedback for keyboard controls. European/ISO 8859-1,2 (Hungarian, English, Czech, etc), Cyrillic and Korean fonts are supported along with 12 subtitle formats (MicroDVD, SubRip, OGM, SubViewer, Sami, VPlayer, RT, SSA, AQTitle, JACOsub, PJS and our own: MPsub). DVD subtitles (SPU streams, VOBsub and Closed Captions) are supported as well.

What is a GUI?

GUI is an acronym for "graphical user interface". In very general terms, a GUI lets you interact with your computer using pictures and symbols in addition to entering typed text. Examples of GUIs include Mac OS, Mac OS X, Microsoft Windows, and the X Window System. The purpose of a GUI is to make a computer easier to use. Rather than having to memorize many complicated commands and type them precisely, you may point and click with an input device, usually a mouse, to run programs or manipulate files.

Why:

* Media Player Classic is damn slow (with certain combinations of codecs), BSPlayer not much better
* ALShow doesn't support .srt subtitles
* MPUI is not very customizable and is ugly and not very fast...
* VLC's subtitles are awful
* MPlayer rules, but without GUI is useless

What is MPlayer?

MPlayer is a free and open source media player distributed under the GNU General Public License. MPlayer is a command line application which has different optional GUIs for each of its supported operating systems. The program is available for all major operating systems, including Linux and other Unix-like systems, Microsoft Windows and Mac OS X. Versions for AmigaOS and MorphOS are also available. MPlayer is known to support a wide variety of media formats. In addition to its wide range of supported formats MPlayer can also save all streamed content to a file. MPlayer was previously called "MPlayer - The Movie Player for Linux" by its developers but this was later shortened to "MPlayer - The Movie Player" after it was made available for multiple operating systems. MPlayer is arguably the best media player application of the world.


Installing rulesPlayer

rulesPlayer is distributed as a single executable installer which will extract all files. Download rulesPlayer file from the homepage: http://rulesplayer.altervista.org/ or from the rulesPlayer Project Page at Dsource.org.

Installing rulesPlayer for first time users:

- Select the Full Package with Installer.
- Download the rulesPlayer installer and install to the default folder.
- During installation, make sure ''Check for latest MPlayer version and download it'' is selected.
- For codecs, select ''Download all codecs'' .

Installer options explained:

"Check for latest MPlayer version and install it"
This option will check rulesPlayer's website for information about the latest MPlayer version and will try to download and install it automatically. This is the preferred way of installing.

"Download the default MPlayer version and install it"
If the installer is unable to get information about newer version of MPlayer, it will try to download a 'default' version. This is the most up-to-date version the at time of installer's creation.

"I have MPlayer release and I want to use it"
In case you prefer to download MPlayer and it's codecs manually, you can choose this options and then browse for the two .zip files. One containing MPlayer and one containing codecs for MPlayer.

"I will install MPlayer manually"
Use this if you don't want the installer to install MPlayer or any codecs. Note that without MPlayer, you will be unable to use the program.

"Download all codecs"
This option is used when installing MPlayer automatically. It will install all available MPlayer codecs.

"Download essential codecs"
This option is used when installing MPlayer automatically. It will install only the most important MPlayer codecs.


Features

rulesPlayer Features

* Low system requirements
* Powerful subtitles engine
* Playback of incomplete AVI-files
* Supports command line parameters.
* Register all supported video formats with rulesPlayer
* Multi-language support
* Resolution changing
* Playlist. Allows you to enqueue several files to be played one after each other.
* Audio track switching. You can choose the audio track you want to listen.
* AVI files with more than 2 audio streams supported
* External audio file support
* Video equalizer, allows you to adjust the brightness, contrast, hue, saturation.
* Resizable movie window
* Drag & drop support
* Screen capture
* Full tray icon controls
* On Screen Display (OSD)
* Integrated Controls: play, pause, stop, previous, next and seek
* Keyboard shortcut controls enabled
* Manual resize support
* Used file info and more....

Supported Input Formats

* (S)VCD (Super Video CD)
* CDRwin's .bin image file
* DVD, including encrypted DVD
* MPEG-1/2 (ES/PS/PES/VOB)
* RIFF AVI file format
* ASF/WMV/WMA format
* QT/MOV/MP4 format
* RealAudio/RealVideo format
* Ogg/OGM files
* Matroska
* NUT
* NSV (Nullsoft Streaming Video)
* VIVO format
* FLI format
* NuppelVideo format
* yuv4mpeg format
* FILM (.cpk) format
* RoQ format
* PVA format
* streaming via HTTP/FTP, RTP/RTSP, MMS/MMST, MPST, SDP

Supported Video and Audio Codecs

- most important video codecs:

* MPEG-1 (VCD) and MPEG-2 (SVCD/DVD/DVB) video
* MPEG-4 in all variants including DivX ;-), OpenDivX (DivX4), DivX 5 (Pro), XviD
* Windows Media Video 7/8 (WMV1/2)
* Windows Media Video 9 (WMV3) (using x86 DLL)
* RealVideo 1.0, 2.0 (G2)
* RealVideo 3.0 (RP8), 4.0 (RP9) (using Real libraries)
* Sorenson v1/v3 (SVQ1/SVQ3), Cinepak, RPZA and other QuickTime codecs
* DV video
* 3ivx
* Intel Indeo3 (3.1, 3.2)
* Intel Indeo 4.1 and 5.0 (using x86 DLL or XAnim codecs)
* VIVO 1.0, 2.0, I263 and other H.263(+) variants (using x86 DLL)
* MJPEG, AVID, VCR2, ASV2 and other hardware formats
* FLI/FLC
* HuffYUV
* various old simple RLE-like formats

- most important audio codecs:

* MPEG layer 1, 2, and 3 (MP3) audio
* AC3/A52 (Dolby Digital) audio (software or SP/DIF)
* AAC (MPEG-4 audio)
* WMA (DivX Audio) v1, v2
* WMA 9 (WMAv3), Voxware audio, ACELP.net etc (using x86 DLLs)
* RealAudio: COOK, SIPRO, ATRAC3 (using Real libraries)
* RealAudio: DNET and older codecs
* QuickTime: Qclp, Q-Design QDMC/QDM2, MACE 3/6 (using QT libraries), ALAC
* Ogg Vorbis audio
* VIVO audio (g723, Vivo Siren) (using x86 DLL)
* alaw/ulaw, (ms)gsm, pcm, *adpcm and other simple old audio formats

The codec status page of MPlayer has the complete list and is updated daily.


''File'' menu

* Open file(s) - open file dialog.

* Open folder - opens a browse window to select a entire folder you want to play.

* Open URL - connect to a streaming media file on the Internet or other network.

* Play DVD - opens DVD.

* Close - close the player dialog and returns you to the main window.

* Restart - restart while playing.

* Recent files - opens last visited directories and recent files list.

* Clip information - shows file properties like resolution, size, codec and other useful info.

* About - shows the version number of rulesPlayer you are actually using and the credits.

* MPlayer priority - set process priority for MPlayer according to Windows predefined priorities:

- idle
- below normal
- normal -> Default.
- above normal
- high
- realtime -> This setting may cause a system lockup.

* Associations - check or uncheck the file types you want rulesPlayer to play by default.

* Exit - closes rulesPlayer and returns you to Windows.


''Playback'' menu

* Play - plays the open multimedia file.

* Pause - temporarily suspend the playing process.

* Stop - stops the playing process.

* Increase/Decrease speed - decrease/increase current playback speed by 10%.

* Next/Previous file - play next/previous file in the playlist.

* Shuffle - play files in random order.

* Repeat - makes rulesPlayer to repeat the file once and again.

* Autoplay - play CDs automatically in rulesPlayer

* Autodetect sequence files - autodetect and read a sequence file format.


''Video'' menu

* OSD mode - shows/hides on screen display menus.

* Framedrop - this will allow rulesPlayer not to render a frame here and there if the CPU can't handle it.

* Postprocessing - on every image in the movie is applied a filter to reduce square areas.

* Aspect ratio - resize and maintain aspect ratio:

- the traditional 4:3
- modern 16:9 (international standard format of HDTV)
- 2.35:1 35 mm anamorphic used by CinemaScope ("'Scope") and early Panavision.

* Reset color controls - set equalizer to default values.

* Keep aspect ratio - keep the original aspect ratio.

* Deinterlace - convert interlaced video sequence of fields into a non-interlaced form (sequence of frames).

* Rebuild index - useful for broken AVI streams where the last part of the original file is missing.

* Fullscreen mode - permanently enable the fullscreen mode in rulesPlayer.

* Compact mode - no title bar, menu bar and navigation bar.


''Audio'' menu

* Track - switch between two audio tracks.

* Output - audio output drivers are interfaces to different audio output facilities:

- disabled -> audio output disabled.
- Win32 -> native Windows waveout audio output driver.
- DirectSound -> DirectX DirectSound audio output driver.
- Disk writer -> output plugin which writes to a .WAV file instead of the sound card.

* Volume - increase audio volume by 10/20...% or keep the original audio volume.

* Load external file - allows to watch videos when the audio track is an external file (mp3, wav...)

* Mute - mute or un-mute audio.


''Subtitles'' menu

* Track - select a subtitle track.

* Size - change the subtitle size in rulesPlayer.

* Black band - create an extra black band at the bottom of the screen where you will place the subtitles.

* Codepage - set subtitle language codepage for your country.


Default Key Bindings

Playlist (buitin can not be changed):

Del - delete selected items
Enter - play current item
Alt+Up - move selection up
Alt + Down - move selection down
Escape - close playlist

Console (buitin can not be changed):

Escape - close console

General (bindings):

1 - decrease brightness
2 - increase brightness
3 - decrease conrast
4 - increase conrast
5 - decrease saturation
6 - increase saturation
7 - decrease hue
8 - increase hue
9 - decrease volume
0 - increase volume
arrow down - step one frame
arrow left - seek back 5 seconds
arrow right - seek forward 5 seconds
ctrl+arrow left - seek back 60 seconds
ctrl+arrow right - seek forward 60 seconds
page up - seek back 600 seconds
page down - seek forward 600 seconds
ctrl+arrow up - increase playback speed
ctrl+arrow down - decrease playback speed
alt+arrow up - move subtitles up
alt+arrow down - move subtitles down
o - change osd mode
v - toggle subtitles visibility
s - take screenshot
f - toggle fullscreen mode
c - toggle compact mode
d - change frame drop mode
p - toggle playlist
j - search the playlist
t - toggle stick on top
` (tilde) - show console (escape to hide it)
escape - hide playlist or console (depending on which one has the focus)
spacebar - play/pause
enter - set window size to 100%
mouse1 - play/pause
mouse1 double - fullscreen
mouse3 - context menu
ctrl+mouse3 - OS shell menu
wheelup - audio volume +5%
wheeldown - audio volume -5%


Reseting to Default Settings

If you screwed up something or you installed new version of the player without uninstalling the old one you can the the following:

Type in the console (without the quotes)

"unsetall && unaliasall && unbindall && exec default.kfg && resetall"

Note that this will erase all your key bindings, aliases, configurations!

So if there is something you want to keep i suggest using autoexec.cfg or learn to like what i like (i.e. my defaults). Also note that it is not always necessary to reset any configuration after installing a new version.


The Console

The console is the only way to configure rulesPlayer. Some common commands and variables are put in the menus or controls but they all refer to console commands/variables.

It is this way because:

1) i like quake
2) it is faster
3) it is flexible
4) i am too lazy to code interfaces

* tab is autocomplete (it will complete built-in commands, aliases and variables)
* help will display list of built-in commands
* commands are handled like on the command line
* "cmd1 && cmd2" (w/o quotes) will execute both cmd1 and cmd2
* $N, where N is number, is replaced with command argument N
* $N, where N is string, is replaced with variable named N
* $#N, where N is number, is replaced with string with id N
* $#N, where N is string or nothing, is replaced with #N
* $$ is replaced with $
* $% is replaced with nothing. it is meant for separator
* $& is replaced with &
* if you prefix a command with @ it will not be echoed to the console
* for some examples open config.kfg or default.kfg
* \" is replaced with "
* \\ is replaced with \
* \t is replaced with tab
* \n is replaced with new line


Some Stuff Explained

Default subtitle language:
This is a feature used with the subtitle auto loading (the second can be disabled from the subtitles menu). type in the console "sub_deflang en,eng,jpn,de" to set default languages in order of preference. It work like this - if you have a movie named mymovie.avi and few subtitles in the same folder, say mymovie.jpn.sub and mymovie.de.sub, the both subtitles will be loaded automatically when you open the movie and jpn subtitle will be chosen automatically (because it is before de). It also works for built in subtitles.

Registering a file extension with the player:
you can choose to register all supported video formats with rulesPlayer from the file menu (existing associations will be backed up so you can unregister later) or you can use the console to register specific extensions. Open the console and type "registerext .avi „my description" 3', where 3 is number of the icon displayed in explorer. you can see the available icons in the images folder of your installation, the default one is number one (1_player.ico).

Config files:
Each line in the config files is interpreted as line in the console with one exception. There is support for multiline commands. If the line ends with \ (and not \\), the interpreter will continue reading lines until line without ending \ character is found or it reaches the end of the file. the \ character is skipped.
the configruation files must be in utf8 encoding.

Key/mouse bindings note:
Basically you can bind keys like that: bind ctrl+a "yell test", and when you pres ctrl+a you will see a message box saying "text". for more help about the bindings see default.kfg
you can bind mouse and keys with ctrl,alt and shift modifiers, but you can't bind mouse and keys together. this means that ctrl+a is valid binding, ctrl+mouse1 too, but ctrl+a+mouse1 will ignore the a key.

Console and playlist size:
You can resize both the console and the playlist windows. there is no resize cursor, but just click and drag at the bottom/top border of the window...

A tip for the compact mode:
You can find something like this useful. type in the console: bind c "titlebar && compact && @wndsize 1"
the next time you press 'c' the titlebar of the window will be hidden and it will be resized after the movie.

Events:
rulesPlayer supports simple events in the form of aliases. When some events occurs a command (alias) will be triggered if it is defined. the supported events are:
oninit - when the player starts
onexit - when the player exits
onrestart - when the movie is restarted (usually to change the arguments of mplayer). $1 is the path to the movie
onplay - when movie playback starts (and when the movie is restarted too). $1 is the path to the movie
onclose - when movie playback ends. $1 is the path to the movie
onafterplayback - when all movies in they playlist finished playback. if the $pl_autoadvance is 0 this will be triggered after current movie ends. if the playlist repeat is on this will never be triggered
example: alias onplay "yell \"now playing the movie $$1\""


Frequently Asked Questions

- How to change subtitles codepage?
Type this in the console: sub_codepage latin2

- How to pass custom parameters to MPlayer?
Type this in the console: mp_more "your stuff goes here"

- How to change associated files' icon?
Type this in the console: fileicon 2, where 2 is number from 0 to 5, and associate the files again. To see what the icons look like right-click the rulesPlayer shortcut/properties/change icon

- Why my screen color corrections won't affect the video inside rulesPlayer?
Because it is an overlay surface. Use overlay color controls of your video card or the built in color controls.

- The videos appear too bright, what should I do?
First check the overlay color controls of your video. You can also try this solution posted in the forum here...

- Can I make the left mouse drag the window instead of pausing the movie?
Type this (no quotes): "bind mouse1 @dragwindow" . Note that it works only with the primary mouse button.

- How about Drag & Drop support?
You can drag/drop to the player and to the playlist but for the moment only files. If you want to stream online content you have to copy the link location and the paste in "open url.../".

- Subtitles won’t display!
Check the subtitles menu. There is an item called "don't auto load subtitles", it should be unchecked for your purpose. If it is still not working try to drag the subtitle file on the player or use file/open. However, you have to make sure that your subtitles have exactly the same title as the main video file (.AVI). To give you an example:

* Video file name: Test.avi
* Subtitle name: Test.srt

- How do I capture a screenshot of a movie?
Try to press ''S'' on your keyboard. The screenshots are located in your rulesPlayer default directory (C:\Program Files\rulesPlayer) .

- How do I associate file types with rulesPlayer?
From the ''File'' menu, select ''Associations''. Select "Register videos with rulesPlayer''.

- Can i use rulesPlayer to preview partially downloaded files on eMule ?
Yes, you can after installing rulesPlayer you have to go to eMule’s Options screen, next go to the Files section and under video player browse for the ''player.exe'' executable (which is usually located in C:\Program Files\rulesPlayer\player.exe) , then uncheck the “Create Backup to Preview” option. Once eMule is set up in that way you can preview any video file you download before you finish downloading it, you will have to wait until eMule downloads the first and last chunk of the file. Once eMule downloads these chunks the “Preview” option will be available (un-grayed) under the context menu of the downloading file.

- Can I listen to Winamp radio stations?
Yes you can. Once you've installed rulesPlayer, go to File, Open URL, and enter the address of the ShoutCast stream you want to hear. A good place to start looking for ShoutCast streams is ShoutCast.com

- My question isn't answered in this FAQ. What can I do?
The first and perhaps best advice is to check the rulesPlayer forums. Just be sure you are polite and state your problem properly.

- How you can help the rulesPlayer project?
These are some files advertising rulesPlayer. Download, distribute and display these to help tell others about rulesPlayer.